using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DataPointsWithLabels
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
    {
		private System.Windows.Forms.Label label1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		const int    myNumSamples = 10;
		const int    myXYSet = 2;
        private XYChartNet.XYChartNETCtl xyChartNETCtl1;
		double [,] ChartData = new double [myNumSamples, myXYSet];

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			Font       myFont    = new Font("Arial", 16, FontStyle.Bold | FontStyle.Italic);
			double     NullDataValue = 1.79 * Math.Pow(10, 308);

            xyChartNETCtl1.Dock = DockStyle.Fill;

			// Configure XY Chart NET control
			xyChartNETCtl1.NumProfiles = 1;
			xyChartNETCtl1.NumXScales = 1;
			xyChartNETCtl1.NumYScales = 1;

			// Legend
			xyChartNETCtl1.Legend.Visible = true;
			xyChartNETCtl1.Legend.BorderVisible = false;
			xyChartNETCtl1.Legend.YScaleVisible = false;
			
			xyChartNETCtl1.Title.Label = "Data Points";
			xyChartNETCtl1.Title.Font = myFont;
			xyChartNETCtl1.Title.Color = Color.White;

			// Toolbar
			xyChartNETCtl1.Toolbar.Visible = true;
			xyChartNETCtl1.Toolbar.BackColor = Color.Lavender;

			// Chart & plot formatting
            xyChartNETCtl1.BackColor = Color.SteelBlue;
            xyChartNETCtl1.Gradient.GradientOption = XYChartNet.XYChartNETCtl.GradientOptions.goCustom;
            xyChartNETCtl1.Gradient.Orientation = XYChartNet.XYChartNETCtl.OrientationOptions.ooVertical;
            xyChartNETCtl1.Gradient.StartColor = Color.SteelBlue;
            xyChartNETCtl1.Gradient.EndColor = Color.Blue;

			// Crosshairs
			xyChartNETCtl1.Crosshairs.YCoordInLegend = true;
			xyChartNETCtl1.Crosshairs.Color = Color.Blue;
			xyChartNETCtl1.Crosshairs.Width = XYChartNet.XYChartNETCtl.WidthOptions.woTwoPoint;
			xyChartNETCtl1.Crosshairs.CoordsBackcolor = Color.Green;
			xyChartNETCtl1.Crosshairs.HorizontalVisible = false;
			xyChartNETCtl1.Crosshairs.VerticalVisible = true;

			// Plot formatting
			xyChartNETCtl1.Plot.BackColor = Color.Lavender;
			xyChartNETCtl1.Plot.Border.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loNone;

			// X Axis Grid & Scale properties
			XYChartNet.XYChartNETCtl.C_XSCALEPROP xAxis;
            xAxis = xyChartNETCtl1.get_XAxis(0);
			xAxis.Grid.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
			xAxis.Grid.LineColor = Color.Green;
			xAxis.Scale.Label = "";
			xAxis.Scale.LabelColor = Color.White;
			xAxis.Scale.TicksColor = Color.White;
			xAxis.Scale.ScaleMode = XYChartNet.XYChartNETCtl.ScaleModes.smAuto;

			// Y Axis Grid & Scale properties
			XYChartNet.XYChartNETCtl.C_YSCALEPROP yAxis;
			yAxis = xyChartNETCtl1.get_YAxis(0);
			yAxis.Scale.ForceZeroDisplay = true;
			yAxis.Grid.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
			yAxis.Grid.LineColor = Color.Green;
			yAxis.Scale.Label = "";
			yAxis.Scale.LabelColor = Color.White;
			yAxis.Scale.TicksColor = Color.White;
			yAxis.Scale.ScaleMode = XYChartNet.XYChartNETCtl.ScaleModes.smAuto;

			// Profile 0
			XYChartNet.XYChartNETCtl.C_Profile profile;
			profile = xyChartNETCtl1.get_Profile(0);
			profile.XScale = 0;
			profile.YScale = 0;
			profile.Label = "Profile 0";
			profile.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
			profile.LineWidth = XYChartNet.XYChartNETCtl.WidthOptions.woOnePoint;
			profile.LineStyle = XYChartNet.XYChartNETCtl.StyleOptions.soSolid;
			profile.LineColor = Color.Maroon;
			profile.MarkerOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
			profile.MarkerStyle = XYChartNet.XYChartNETCtl.MarkerStyleOptions.msDiamond;
			profile.MarkerSize = 4;
			profile.MarkerFillColor = Color.Maroon;
			profile.MarkerBorderColor = Color.Maroon;
			profile.NumSamples = myNumSamples;

			// Create random chart data, then feed into XYChartNET
			Random rnd = new Random();
			for (int i = 0; i < myNumSamples; i++)
			{
				ChartData[i, 0] = i * 1;
				ChartData[i, 1] = 100 * rnd.NextDouble();
			}
			xyChartNETCtl1.ChartData = ChartData;

			xyChartNETCtl1.Refresh();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.label1 = new System.Windows.Forms.Label();
            this.xyChartNETCtl1 = new XYChartNet.XYChartNETCtl();
            this.SuspendLayout();
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(552, 352);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(48, 16);
            this.label1.TabIndex = 1;
            this.label1.Text = "label1";
            this.label1.Visible = false;
            // 
            // xyChartNETCtl1
            // 
            this.xyChartNETCtl1.BackColor = System.Drawing.SystemColors.Control;
            this.xyChartNETCtl1.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("xyChartNETCtl1.BackgroundImage")));
            this.xyChartNETCtl1.Border.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loNone;
            this.xyChartNETCtl1.CausesValidation = false;
            this.xyChartNETCtl1.CustomToolbar.BackColor = System.Drawing.SystemColors.Control;
            this.xyChartNETCtl1.Location = new System.Drawing.Point(32, 34);
            this.xyChartNETCtl1.LogEvent.CTRLInstName = "xyChartNETCtl1";
            this.xyChartNETCtl1.LogEvent.FormName = "Form1";
            this.xyChartNETCtl1.Name = "xyChartNETCtl1";
            this.xyChartNETCtl1.Size = new System.Drawing.Size(415, 283);
            this.xyChartNETCtl1.TabIndex = 2;
            this.xyChartNETCtl1.Title.Font = new System.Drawing.Font("Arial", 8F);
            this.xyChartNETCtl1.Toolbar.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(211)))), ((int)(((byte)(222)))), ((int)(((byte)(237)))));
            this.xyChartNETCtl1.PlotDoubleClick += new XYChartNet.XYChartNETCtl.PlotDoubleClickEventHandler(this.XYChartNETCtl1_PlotDoubleClick);
            this.xyChartNETCtl1.Paint += new System.Windows.Forms.PaintEventHandler(this.XYChartNETCtl1_Paint);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(704, 478);
            this.Controls.Add(this.xyChartNETCtl1);
            this.Controls.Add(this.label1);
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Form1";
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void XYChartNETCtl1_Paint(object sender, System.Windows.Forms.PaintEventArgs e) 
		{
			Font myFont= new Font("Arial", 8, FontStyle.Bold);
			string strLabel;

			double XValue;
			double YValue;
			double XPos;
			double YPos;

			const Single X_OFFSET = 4;
			const Single Y_OFFSET = 4;

			label1.Font = myFont;

			for (int i = 0; i < myNumSamples; i++)
			{
				XValue = ChartData[i, 0];
				YValue = ChartData[i, 1];

				// Check DataPoint is within the plot area (in case user has zoomed in)
				if (XValue >= xyChartNETCtl1.get_MinXValue(0) & XValue <= xyChartNETCtl1.get_MaxXValue(0) & YValue >= xyChartNETCtl1.get_MinYValue(0) & YValue <= xyChartNETCtl1.get_MaxYValue(0))
				{
					strLabel = "[" + Math.Round(ChartData[i, 0],1).ToString()  + ", " + Math.Round(ChartData[i, 1],1).ToString()  + "]";
					label1.Text = strLabel; // Use to get width and height of text string

					XPos = xyChartNETCtl1.get_YStack(0).Left + xyChartNETCtl1.get_YStack(0).Width * (XValue - xyChartNETCtl1.get_MinXValue(0)) / (xyChartNETCtl1.get_MaxXValue(0) - xyChartNETCtl1.get_MinXValue(0));
					YPos = xyChartNETCtl1.get_YStack(0).Top + xyChartNETCtl1.get_YStack(0).Height * (xyChartNETCtl1.get_MaxYValue(0) - YValue) / (xyChartNETCtl1.get_MaxYValue(0) - xyChartNETCtl1.get_MinYValue(0));

					// Make sure label does not cross outside the plot area
					if ((XPos + label1.Width + X_OFFSET) > (xyChartNETCtl1.get_YStack(0).Left + xyChartNETCtl1.get_YStack(0).Width - 1)) 
					{
						// Position to the left of the datapoint
						XPos = XPos - label1.Width - X_OFFSET;
					}
					else
					{
						// Position to the right of the datapoint
						XPos = XPos + X_OFFSET;
					}

					// Make sure label does not cross outside the plot area
					if ((YPos + label1.Height + Y_OFFSET) > (xyChartNETCtl1.get_YStack(0).Top + xyChartNETCtl1.get_YStack(0).Height - 1)) 
					{
						// Position above the datapoint
						YPos = YPos - label1.Height - Y_OFFSET;
					}
					else
					{
						// Position below the datapoint
						YPos = YPos + Y_OFFSET;
					}

					// Display Label
					e.Graphics.DrawString(strLabel, myFont,  Brushes.Blue, (float)XPos, (float)YPos);

				}
			}
		}

		private void XYChartNETCtl1_PlotDoubleClick(int Index, int xPos, int yPos)
		{
			xyChartNETCtl1.SetZoomOutAll(  );
		}
	}
}
