using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace WindowsApplication1
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
    {
		private System.Windows.Forms.Panel pnlXY;
		private System.Windows.Forms.Label lblXY;
        private XYChartNet.XYChartNETCtl XYChartNETCtl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			const double pi = 3.14159265358979;
			const int    myNumSamples = 40;
			const int    myXYSet = 4;

			double     val;
			double [,] DataArray = new double [myNumSamples, myXYSet];
			Font       myFont    = new Font("Arial", 16, FontStyle.Bold | FontStyle.Italic);
			Font       my12Font    = new Font("Arial", 12, FontStyle.Bold | FontStyle.Italic);
			Font       my10Font    = new Font("Arial", 10, FontStyle.Bold);

			pnlXY.BackColor=Color.LightCyan;
			lblXY.BackColor=Color.LightCyan;
			lblXY.ForeColor=Color.DarkGreen;
			lblXY.Font = my10Font;
			lblXY.Text="[X,Y] = ";

            XYChartNETCtl1.Dock = DockStyle.Fill;

			// Configure XY Chart NET control
			XYChartNETCtl1.NumProfiles = 2;
			XYChartNETCtl1.NumXScales = 1;
			XYChartNETCtl1.NumYScales = 1;

			XYChartNETCtl1.Title.Label="Label reports nearest X,Y point when mouse moves over a profile";
			XYChartNETCtl1.Title.Color =Color.Blue;
			XYChartNETCtl1.Title.Font=my12Font;


			// Zoom window
			XYChartNETCtl1.ZoomWindowColor = Color.Yellow;

			// Gradient
			XYChartNETCtl1.Gradient.GradientOption = XYChartNet.XYChartNETCtl.GradientOptions.goCustom;
			XYChartNETCtl1.Gradient.StartColor = Color.LightCyan;
			XYChartNETCtl1.Gradient.EndColor = Color.DarkCyan;
			XYChartNETCtl1.Gradient.Orientation = XYChartNet.XYChartNETCtl.OrientationOptions.ooVertical;

			// Plot formatting
			XYChartNETCtl1.Plot.Transparent = true;
			XYChartNETCtl1.Plot.Border.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loNone;

			// Toolbar
			XYChartNETCtl1.Toolbar.Visible = true;
			XYChartNETCtl1.Toolbar.BackColor = Color.LightCyan;
			XYChartNETCtl1.Toolbar.Dock = XYChartNet.XYChartNETCtl.PositionOptions.poTop;

			// Format Legend
			XYChartNETCtl1.Legend.Visible = true;
			XYChartNETCtl1.Legend.BorderVisible = false;
			XYChartNETCtl1.Legend.YScaleVisible = false;
			
			// X Axis Grid & Scale properties
			XYChartNet.XYChartNETCtl.C_XSCALEPROP xAxis;
			xAxis = XYChartNETCtl1.get_XAxis(0);
			xAxis.Grid.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
			xAxis.Grid.LineColor = Color.Green;
			xAxis.Scale.Label = "Time (ms)";
			xAxis.Scale.LabelColor = Color.Black;
			xAxis.Scale.TicksColor = Color.Black;
			xAxis.Scale.ScaleMode = XYChartNet.XYChartNETCtl.ScaleModes.smAuto;
			xAxis.Scale.ScaleType = XYChartNet.XYChartNETCtl.ScaleTypes.stLog;

			// Y Axis Grid & Scale properties
			XYChartNet.XYChartNETCtl.C_YSCALEPROP yAxis;
			yAxis = XYChartNETCtl1.get_YAxis(0);
			yAxis.Grid.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
			yAxis.Grid.LineColor = Color.Green;
			yAxis.Scale.Label = "Volts";
			yAxis.Scale.LabelColor = Color.Black;
			yAxis.Scale.TicksColor = Color.Black;
			yAxis.Scale.ScaleMode = XYChartNet.XYChartNETCtl.ScaleModes.smAuto;
			yAxis.Scale.ScaleType = XYChartNet.XYChartNETCtl.ScaleTypes.stLog;

			XYChartNet.XYChartNETCtl.C_Profile profile;

			// Format Profile 0
			profile = XYChartNETCtl1.get_Profile(0);
			profile.YScale = 0;
			profile.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
			profile.LineWidth = XYChartNet.XYChartNETCtl.WidthOptions.woThreePoint;
			profile.LineStyle = XYChartNet.XYChartNETCtl.StyleOptions.soSolid;
			profile.MarkerOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
			profile.MarkerSize = 3;
			profile.MarkerBorderColor= Color.Blue;
			profile.MarkerFillColor= Color.Blue;
			profile.LineColor = Color.Blue;
			profile.Label = "SINE";
			profile.NumSamples = myNumSamples;

			// Format Profile 1
			profile = XYChartNETCtl1.get_Profile(1);
			profile.YScale = 0;
			profile.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
			profile.LineWidth = XYChartNet.XYChartNETCtl.WidthOptions.woThreePoint;
			profile.LineStyle = XYChartNet.XYChartNETCtl.StyleOptions.soSolid;
			profile.MarkerOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
			profile.MarkerSize = 3;
			profile.MarkerBorderColor= Color.Red;
			profile.MarkerFillColor= Color.Red;
			profile.LineColor = Color.Red;
			profile.Label = "COSINE";
			profile.NumSamples = myNumSamples;

			// Generate Sine and Cosine profiles
			for (int row = 0; row < myNumSamples; row++)
			{
				// Profile 0
				val = 2 * pi * row / myNumSamples;
				DataArray[row, 0] = val;
				DataArray[row, 1] =10000* Math.Sin(val)+11000;

				// Profile 1
				DataArray[row, 2] = val;
				DataArray[row, 3] =10000* Math.Cos(val)+11000;
			}

			// Feed source array into XYChart
			XYChartNETCtl1.ChartData = DataArray;

			// Format Crosshairs
			XYChartNETCtl1.Crosshairs.YCoordInLegend = true;
			XYChartNETCtl1.Crosshairs.Color = Color.Lime;
			XYChartNETCtl1.Crosshairs.Width = XYChartNet.XYChartNETCtl.WidthOptions.woTwoPoint;
			XYChartNETCtl1.Crosshairs.CoordsBackcolor = Color.Lime;
			XYChartNETCtl1.Crosshairs.HorizontalVisible = false;
			XYChartNETCtl1.Crosshairs.VerticalVisible = true;

			XYChartNETCtl1.Refresh();

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.pnlXY = new System.Windows.Forms.Panel();
            this.lblXY = new System.Windows.Forms.Label();
            this.XYChartNETCtl1 = new XYChartNet.XYChartNETCtl();
            this.pnlXY.SuspendLayout();
            this.SuspendLayout();
            // 
            // pnlXY
            // 
            this.pnlXY.Anchor = System.Windows.Forms.AnchorStyles.Top;
            this.pnlXY.BackColor = System.Drawing.Color.Transparent;
            this.pnlXY.Controls.Add(this.lblXY);
            this.pnlXY.Location = new System.Drawing.Point(320, 0);
            this.pnlXY.Name = "pnlXY";
            this.pnlXY.Size = new System.Drawing.Size(200, 24);
            this.pnlXY.TabIndex = 1;
            // 
            // lblXY
            // 
            this.lblXY.Location = new System.Drawing.Point(8, 2);
            this.lblXY.Name = "lblXY";
            this.lblXY.Size = new System.Drawing.Size(152, 16);
            this.lblXY.TabIndex = 0;
            this.lblXY.Text = "label1";
            // 
            // XYChartNETCtl1
            // 
            this.XYChartNETCtl1.BackColor = System.Drawing.SystemColors.Control;
            this.XYChartNETCtl1.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("XYChartNETCtl1.BackgroundImage")));
            this.XYChartNETCtl1.Border.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loNone;
            this.XYChartNETCtl1.CausesValidation = false;
            this.XYChartNETCtl1.CustomToolbar.BackColor = System.Drawing.SystemColors.Control;
            this.XYChartNETCtl1.Location = new System.Drawing.Point(55, 54);
            this.XYChartNETCtl1.LogEvent.CTRLInstName = "XYChartNETCtl1";
            this.XYChartNETCtl1.LogEvent.FormName = "Form1";
            this.XYChartNETCtl1.Name = "XYChartNETCtl1";
            this.XYChartNETCtl1.Size = new System.Drawing.Size(521, 315);
            this.XYChartNETCtl1.TabIndex = 2;
            this.XYChartNETCtl1.Title.Font = new System.Drawing.Font("Arial", 8F);
            this.XYChartNETCtl1.Toolbar.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(211)))), ((int)(((byte)(222)))), ((int)(((byte)(237)))));
            this.XYChartNETCtl1.PlotMouseMove += new XYChartNet.XYChartNETCtl.PlotMouseMoveEventHandler(this.XYChartNETCtl1_PlotMouseMove);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(776, 446);
            this.Controls.Add(this.pnlXY);
            this.Controls.Add(this.XYChartNETCtl1);
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Form1";
            this.pnlXY.ResumeLayout(false);
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

        private void XYChartNETCtl1_PlotMouseMove(System.Windows.Forms.MouseButtons Button, int Index, int xPos, int yPos)
        {
            double XValue = 0;
            double YValue = 0;
            int Profile;

            for (Profile = 0; Profile < XYChartNETCtl1.NumProfiles; Profile++)
            {
                if (GetNearestDataPoint(Index, xPos, yPos, Profile, ref XValue, ref YValue))
                {
                    lblXY.Text = "[X,Y] = " + XValue.ToString("#.#") + ", " + YValue.ToString("#.#");
                }
            }
        }

		// Gets nearest data point within window, and sets profile, row sample in array, and the actual X & Y values
		// Returns True if data point within window, else returns False
		// Index     YScale index
		// xPos      Mouse X position wrt the entire XYChart control
		// yPos      Mouse Y position wrt the entire XYChart control
		// Profile   Check if mouse over a data point in this Profile
		// XValue    Returned XValue of found data point
		// YValue    Returned YValue of found data point
		private bool GetNearestDataPoint(int Index, int xPos, int yPos, int Profile, ref double XValue, ref double YValue)
		{
			double MinXValue = 0;
			double MaxXValue = 0;
			double MinYValue = 0;
			double MaxYValue = 0;
			int PointSelWinX = 0;
			int PointSelWinY = 0;
			bool PointFound = false;
			double[,] arrProfile = null;
			long Row = 0;

			object objProfileArray;

			// Tolerance window in pixels
			PointSelWinX = 5;
			PointSelWinY = 5;

			GetXY(Index, xPos - PointSelWinX, yPos + PointSelWinY, ref MinXValue, ref MinYValue);
			GetXY(Index, xPos + PointSelWinX, yPos - PointSelWinY, ref MaxXValue, ref MaxYValue);

			// Find SampleNum in Profile
			for (Profile = 0; Profile < XYChartNETCtl1.NumProfiles; Profile++)
			{
				objProfileArray = new double[XYChartNETCtl1.get_Profile(Profile).NumSamples,2];
				objProfileArray = XYChartNETCtl1.get_ProfileData(Profile);
				arrProfile = (double[,])objProfileArray;
				for (Row = 0; Row < XYChartNETCtl1.get_Profile(Profile).NumSamples; Row++)
				{
					if (arrProfile[Row, 0] >= MinXValue & arrProfile[Row, 0] <= MaxXValue) // Is X value in window?
					{
						if (arrProfile[Row, 1] >= MinYValue & arrProfile[Row, 1] <= MaxYValue) // Is Y value in window?
						{
							PointFound = true;
							break;
						}
					}
				}
				if (PointFound)
				{
					break;
				}
			}

			if (PointFound)
			{
				XValue = arrProfile[Row, 0];
				YValue = arrProfile[Row, 1];
			}
			return PointFound;
		}

		//Returns dXValue and dYValue coordinates based on xPos and yPos
		private void GetXY(int Index, int xPos, int yPos, ref double dXValue, ref double dYValue)
		{
			int XScale = 0;
			int YScale = 0;
			int YScaleStack = 0; // Rightmost Y scale (must be 1 to determine X values)
			double YStackWidth = 0;
			double YStackHeight = 0;

			const int YScaleRM = 0;

			XScale = 0; // Change this value to any available XScale

			if (XYChartNETCtl1.YStacking)
			{
				YScale = Index; // Uses Index to determine the appropriate YScale
				YScaleStack = YScale;
			}
			else
			{
				YScale = 0; // Change this value to any available YScale
				YScaleStack = 0; // Only 1 plot area when YStacking = False
			}

			// Determine X & Y values
			if (XYChartNETCtl1.get_XAxis(XScale).Scale.ScaleType == XYChartNet.XYChartNETCtl.ScaleTypes.stLinear)
			{
				// Linear X Scale
				YStackWidth = XYChartNETCtl1.get_YStack(YScaleRM).Width;
				dXValue = (xPos - XYChartNETCtl1.get_YStack(YScaleRM).Left)/ YStackWidth * (XYChartNETCtl1.get_MaxXValue(XScale) - XYChartNETCtl1.get_MinXValue(XScale)) + XYChartNETCtl1.get_MinXValue(XScale);
			}
			else
			{
				// Log X Scale
				YStackWidth = XYChartNETCtl1.get_YStack(YScaleRM).Width;
				dXValue = (System.Math.Pow(10, ((xPos - XYChartNETCtl1.get_YStack(YScaleRM).Left) / YStackWidth * (System.Math.Log10(XYChartNETCtl1.get_MaxXValue(XScale)) - System.Math.Log10(XYChartNETCtl1.get_MinXValue(XScale))) + System.Math.Log10(XYChartNETCtl1.get_MinXValue(XScale)))));
			}

			if (XYChartNETCtl1.get_YAxis(YScale).Scale.ScaleType == XYChartNet.XYChartNETCtl.ScaleTypes.stLinear)
			{
				// Linear Y Scale
				YStackHeight=XYChartNETCtl1.get_YStack(YScaleStack).Height;
				dYValue = XYChartNETCtl1.get_MaxYValue(YScale) - (yPos - XYChartNETCtl1.get_YStack(YScaleStack).Top) / YStackHeight * (XYChartNETCtl1.get_MaxYValue(YScale) - XYChartNETCtl1.get_MinYValue(YScale));
			}
			else
			{
				// Log Y Scale
				YStackHeight=XYChartNETCtl1.get_YStack(YScaleStack).Height;
				dYValue = (System.Math.Pow(10, (System.Math.Log10(XYChartNETCtl1.get_MaxYValue(YScale)) - (yPos - XYChartNETCtl1.get_YStack(YScaleStack).Top) / YStackHeight * (System.Math.Log10(XYChartNETCtl1.get_MaxYValue(YScale)) - System.Math.Log10(XYChartNETCtl1.get_MinYValue(YScale))))));
			}
		}

	}
}
