using System;
using System.Drawing;
using System.Drawing.Drawing2D;


class modXYChart 
{ 
	public const double PI = 3.14159265358979; 
	public double NULL_DATA_VALUE = 1.79 * Math.Pow(10, 308); 

	public enum eShape : int 
	{ 
		Rectangle = 0, 
		Elipse = 1 
	} 

	private bool YScaleInYStack(XYChartNet.XYChartNETCtl XYChart, int YScale, int YStack) 
	{ 
		bool functionReturnValue = false; 
    
		int i; 
		int NumYScales; 
    
		try 
		{ 
        
			functionReturnValue = false; 
        
			NumYScales = 0; 
        
		{ 
			if (!XYChart.YStacking) 
			{ 
				functionReturnValue = true; 
			} 
			else 
			{ 
				for (i = 0; i <= YStack; i++) 
				{ 
					if (i == YStack & YScale >= NumYScales & YScale < NumYScales + XYChart.get_YStack(i).NumYScales) 
					{ 
						functionReturnValue = true; 
						break; // TODO: might not be correct. Was : Exit For 
					} 
					else 
					{ 
						NumYScales += XYChart.get_YStack(i).NumYScales; 
					} 
				} 
			} 
		} 
		} 
    
		catch (Exception ex) 
		{ 
			Console.WriteLine(ex.Message); 

		} 
    
		return functionReturnValue; // TODO: might not be correct. Was : Exit Function 
   
	} 

	public void GetPos(int YScale, int YStack, int XScale, ref int xPos, ref int yPos, double dXValue, double dYValue, XYChartNet.XYChartNETCtl XYChart) 
	{ 
    
		// Returns xPos and yPos in pixels given dXValue and dYValue 
    
		try  
			{ 
			// Determine X & Y values 
			if (XYChart.get_XAxis(XScale).Scale.ScaleType == XYChartNet.XYChartNETCtl.ScaleTypes.stLinear) 
			{ 
				// Linear X Scale 
				xPos = Convert.ToInt32((dXValue - XYChart.get_MinXValue(XScale)) / (XYChart.get_MaxXValue(XScale) - XYChart.get_MinXValue(XScale)) * XYChart.get_YStack(0).Width + XYChart.get_YStack(0).Left - 1); 
			} 
			else 
			{ 
				// Log X Scale 
				xPos = Convert.ToInt32((Math.Log(dXValue) / Math.Log(10) - Math.Log(XYChart.get_MinXValue(XScale)) / Math.Log(10)) / (Math.Log(XYChart.get_MaxXValue(XScale)) / Math.Log(10) - Math.Log(XYChart.get_MinXValue(XScale)) / Math.Log(10)) * XYChart.get_YStack(0).Width + XYChart.get_YStack(0).Left - 1); 
			} 
            
			if (XYChart.get_YAxis(YScale).Scale.ScaleType == XYChartNet.XYChartNETCtl.ScaleTypes.stLinear) 
			{ 
				// Linear Y Scale 
				yPos = Convert.ToInt32(XYChart.get_YStack(YStack).Top - (dYValue - XYChart.get_MaxYValue(YScale)) / (XYChart.get_MaxYValue(YScale) - XYChart.get_MinYValue(YScale)) * XYChart.get_YStack(YStack).Height); 
			} 
			else 
			{ 
				// Log Y Scale 
				yPos = Convert.ToInt32(XYChart.get_YStack(YStack).Top - (Math.Log(dYValue) / Math.Log(10) - Math.Log(XYChart.get_MaxYValue(YScale)) / Math.Log(10)) / (Math.Log(XYChart.get_MaxYValue(YScale)) / Math.Log(10) - Math.Log(XYChart.get_MinYValue(YScale)) / Math.Log(10)) * XYChart.get_YStack(YStack).Height); 
			} 

			return;
		} 
        
		catch (Exception ex) 
		{ 
			Console.WriteLine(ex.Message); 
        
		} 
   
} 


	public void DrawShapeOnCanvas(System.Drawing.Graphics gCanvas, XYChartNet.XYChartNETCtl XYChart, int YScale, int XScale, double MinXValue, double MaxXValue, double MinYValue, double MaxYValue, eShape Shape, bool bIncludeHatch, Color BackColor, bool DrawBorder, Color BorderColor, float BorderWidth, HatchStyle HatchStyle, Color HatchColor) 
	{ 
		try 
		{ 
			// Get YStack 
			int YStack; 
		{ 
			for (YStack = 0; YStack <= XYChart.NumYStacks; YStack++) 
			{ 
				if (YScaleInYStack(XYChart, YScale, YStack)) 
				{ 
					break; // TODO: might not be correct. Was : Exit For 
				} 
			} 
		} 
        
			// Set Clip rectangle 
			int x1limit = 0; 
			int y1limit = 0; 
			int x2limit = 0; 
			int y2limit = 0; 

			// Bottom left and Top Right corners
			GetPos(YScale, YStack, XScale, ref x1limit, ref y1limit, XYChart.get_MinXValue (XScale), XYChart.get_MinYValue(YScale), XYChart); 
			GetPos(YScale, YStack, XScale, ref x2limit, ref y2limit, XYChart.get_MaxXValue(XScale), XYChart.get_MaxYValue(YScale), XYChart); 

			gCanvas.SetClip(new Rectangle(x1limit, y2limit, x2limit - x1limit, y1limit - y2limit)); 
        
			// Get 4 corners of shape 
			int x1 = 0; 
			int y1 = 0; 
			int x2 = 0; 
			int y2 = 0; 

			// Bottom left and Top Right corners
			GetPos(YScale, YStack, XScale, ref x1, ref y1, MinXValue, MinYValue, XYChart); 
			GetPos(YScale, YStack, XScale, ref x2, ref y2, MaxXValue, MaxYValue, XYChart); 
			Rectangle myRectangle = new Rectangle(x1, y2, x2 - x1, y1 - y2); 
        
			SolidBrush myBrush; 
			myBrush = new SolidBrush(BackColor); 
        
			switch (Shape) 
			{ 
				case eShape.Elipse: 
					if (bIncludeHatch) 
					{ 
						gCanvas.FillEllipse(new HatchBrush(HatchStyle, HatchColor, BackColor), myRectangle); 
					} 
					else 
					{ 
						gCanvas.FillEllipse(myBrush, myRectangle); 
					} 

					if (DrawBorder) 
					{ 
						gCanvas.DrawEllipse(new Pen(BorderColor, BorderWidth), myRectangle); 
					} 

					break; 
            
				case eShape.Rectangle: 
					// Rectangle 
					if (bIncludeHatch) 
					{ 
						gCanvas.FillRectangle(new HatchBrush(HatchStyle, HatchColor, BackColor), myRectangle); 
					} 
					else 
					{ 
						gCanvas.FillRectangle(myBrush, myRectangle); 
					} 

					if (DrawBorder) 
					{ 
						gCanvas.DrawRectangle(new Pen(BorderColor, BorderWidth), myRectangle); 
					} 

					break; 
            
			} 
        
			gCanvas.ResetClip(); 
		} 
    
		catch  
		{ 
			goto ErrHandler; 
        
		} 
    
		return; // TODO: might not be correct. Was : Exit Sub 
		ErrHandler: 
    
			gCanvas.ResetClip();  
    
	} 

}
