using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace YStacking
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
    {
        private XYChartNet.XYChartNETCtl xyChartNETCtl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			const int myNumSamples = 30;
			const int myXYSet = 4;

			Font       myTitleFont = new Font("Arial", 16, FontStyle.Bold | FontStyle.Italic);
			Font       my14Font = new Font("Arial", 14, FontStyle.Bold);
			Font       my10Font = new Font("Arial", 10, FontStyle.Bold);
			double [,] ChartData = new double [myNumSamples, myXYSet];

            xyChartNETCtl1.Dock = DockStyle.Fill;

			XYChartNet.XYChartNETCtl.C_XSCALEPROP xAxis;
			XYChartNet.XYChartNETCtl.C_YSCALEPROP yAxis;
			XYChartNet.XYChartNETCtl.C_Profile  profile;
			XYChartNet.XYChartNETCtl.C_YStack   yStack;

			// Configure XY Chart NET control
			xyChartNETCtl1.NumProfiles = 2;
			xyChartNETCtl1.NumXScales = 2;
			xyChartNETCtl1.NumYScales = 2;

			xyChartNETCtl1.BackColor = Color.LightSteelBlue;

			xyChartNETCtl1.Title.Label = "Y Stacking";
			xyChartNETCtl1.Title.Font = myTitleFont;
			xyChartNETCtl1.Title.Color = Color.White;

			// Y Stacking
			xyChartNETCtl1.YStacking = true;
			xyChartNETCtl1.NumYStacks = 2;
			// Y Stack 0
			yStack = xyChartNETCtl1.get_YStack(0);
			yStack.HeightPercentage = 70;
			yStack.NumYScales = 1;
			// Y Stack 1
			yStack = xyChartNETCtl1.get_YStack(1);
			yStack.HeightPercentage = 30;
			yStack.NumYScales = 1;

			// Toolbar
			xyChartNETCtl1.Toolbar.Visible = true;
			xyChartNETCtl1.Toolbar.BackColor = Color.LightSteelBlue;

			// Legend
			xyChartNETCtl1.Legend.Visible = true;
			xyChartNETCtl1.Legend.BorderVisible = false;
			xyChartNETCtl1.Legend.YScaleVisible = false;
		
			// Scrollbars
			xyChartNETCtl1.Scrollbars.HorizontalVisible = false;
			xyChartNETCtl1.Scrollbars.VerticalVisible = false;

			// Crosshairs
			xyChartNETCtl1.Crosshairs.YCoordInLegend = true;
			xyChartNETCtl1.Crosshairs.Color = Color.Yellow;
			xyChartNETCtl1.Crosshairs.Width = XYChartNet.XYChartNETCtl.WidthOptions.woTwoPoint;
			xyChartNETCtl1.Crosshairs.CoordsBackcolor = Color.Yellow;
			xyChartNETCtl1.Crosshairs.HorizontalVisible = false;
			xyChartNETCtl1.Crosshairs.VerticalVisible = true;

			// Plot formatting
			xyChartNETCtl1.Plot.BackColor = Color.LightSteelBlue;
			xyChartNETCtl1.Plot.Border.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loNone;

			// X Axis 0 Grid & Scale properties
			xAxis = xyChartNETCtl1.get_XAxis(0);
			xAxis.Grid.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
			xAxis.Grid.LineColor = Color.Maroon;
			xAxis.Scale.Label = "";
			xAxis.Scale.LabelColor = Color.Maroon;
			xAxis.Scale.TicksColor = Color.Maroon;
			xAxis.Scale.TicksFont = my14Font;

			// X Axis 1 Grid & Scale properties
			xAxis = xyChartNETCtl1.get_XAxis(1);
			xAxis.Grid.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
			xAxis.Grid.LineColor = Color.MidnightBlue;
			xAxis.Scale.Label = "";
			xAxis.Scale.LabelColor = Color.MidnightBlue;
			xAxis.Scale.TicksColor = Color.MidnightBlue;
			xAxis.Scale.TicksFont = my10Font;

			// Y Axis 0 Grid & Scale properties
			yAxis = xyChartNETCtl1.get_YAxis(0);
			yAxis.Grid.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
			yAxis.Grid.LineColor = Color.Maroon;
			yAxis.Scale.Label = "";
			yAxis.Scale.LabelColor = Color.Maroon;
			yAxis.Scale.TicksColor = Color.Maroon;
			yAxis.Scale.TicksFont = my14Font;
			yAxis.Scale.ScaleMode = XYChartNet.XYChartNETCtl.ScaleModes.smManual;
			yAxis.Scale.ScaleManualMin = 0;
			yAxis.Scale.ScaleManualMax = 100;

			// Y Axis 1 Grid & Scale properties
			yAxis = xyChartNETCtl1.get_YAxis(1);
			yAxis.Grid.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
			yAxis.Grid.LineColor = Color.MidnightBlue;
			yAxis.Scale.Label = "";
			yAxis.Scale.LabelColor = Color.MidnightBlue;
			yAxis.Scale.TicksColor = Color.MidnightBlue;
			yAxis.Scale.TicksFont = my10Font;
			yAxis.Scale.ScaleMode = XYChartNet.XYChartNETCtl.ScaleModes.smManual;
			yAxis.Scale.ScaleManualMin = 0;
			yAxis.Scale.ScaleManualMax = 500;

			// Profile 0
			profile = xyChartNETCtl1.get_Profile(0);
			profile.XScale = 0;
			profile.YScale = 0;
			profile.Label = "Profile 0";
			profile.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
			profile.LineWidth = XYChartNet.XYChartNETCtl.WidthOptions.woThreePoint;
			profile.LineStyle = XYChartNet.XYChartNETCtl.StyleOptions.soSolid;
			profile.LineColor = Color.Maroon;
			profile.MarkerOption = XYChartNet.XYChartNETCtl.LineOptions.loNone;
			profile.NumSamples = myNumSamples;

			// Profile 1
			profile = xyChartNETCtl1.get_Profile(1);
			profile.XScale = 1;
			profile.YScale = 1;
			profile.Label = "Profile 1";
			profile.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
			profile.LineWidth = XYChartNet.XYChartNETCtl.WidthOptions.woThreePoint;
			profile.LineStyle = XYChartNet.XYChartNETCtl.StyleOptions.soSolid;
			profile.LineColor = Color.MidnightBlue;
			profile.MarkerOption = XYChartNet.XYChartNETCtl.LineOptions.loNone;
			profile.NumSamples = myNumSamples;

			// Create random chart data, then feed into XYChartNET
			Random rnd = new Random();
			for (int i = 0; i < myNumSamples; i++)
			{
				// Profile 0
				ChartData[i, 0] = i * 1;
				ChartData[i, 1] = 70 * rnd.NextDouble() + 20;

				// Profile 1
				ChartData[i, 2] = i * 25;
				ChartData[i, 3] = 450 * rnd.NextDouble();
			}
			xyChartNETCtl1.ChartData = ChartData;

			xyChartNETCtl1.Refresh();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.xyChartNETCtl1 = new XYChartNet.XYChartNETCtl();
            this.SuspendLayout();
            // 
            // xyChartNETCtl1
            // 
            this.xyChartNETCtl1.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("xyChartNETCtl1.BackgroundImage")));
            this.xyChartNETCtl1.Border.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loNone;
            this.xyChartNETCtl1.CausesValidation = false;
            this.xyChartNETCtl1.Location = new System.Drawing.Point(49, 45);
            this.xyChartNETCtl1.LogEvent.CTRLInstName = "XYChartNETCtl1";
            this.xyChartNETCtl1.LogEvent.FormName = "Form1";
            this.xyChartNETCtl1.Name = "xyChartNETCtl1";
            this.xyChartNETCtl1.Size = new System.Drawing.Size(512, 314);
            this.xyChartNETCtl1.TabIndex = 0;
            this.xyChartNETCtl1.Title.Font = new System.Drawing.Font("Arial", 8F);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(777, 486);
            this.Controls.Add(this.xyChartNETCtl1);
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Form1";
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
	}
}
