using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Sample1
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
    {
        private XYChartNet.XYChartNETCtl xyChartNETCtl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			Font myTitleFont = new Font("Arial", 16, FontStyle.Bold | FontStyle.Italic);
			Font my14Font = new Font("Arial", 14, FontStyle.Bold);
			Font my10Font = new Font("Arial", 10, FontStyle.Bold);

			const int	myNumSamples = 20;
			const int	myXYSet = 8;
			double [,]	DataArray = new double [myNumSamples, myXYSet];

            xyChartNETCtl1.Dock = DockStyle.Fill;

			XYChartNet.XYChartNETCtl.C_XSCALEPROP xAxis;
			XYChartNet.XYChartNETCtl.C_YSCALEPROP yAxis;
			XYChartNet.XYChartNETCtl.C_Profile  profile;
			XYChartNet.XYChartNETCtl.C_YStack   yStack;

			//Configure XY Chart NET control
			xyChartNETCtl1.NumProfiles = 4;
            xyChartNETCtl1.NumXScales = 2;
            xyChartNETCtl1.NumYScales = 4;

            xyChartNETCtl1.Title.Label = "Spline and Stairmode";
            xyChartNETCtl1.Title.Font = myTitleFont;
            xyChartNETCtl1.Title.Color = Color.DarkBlue;

            //Y Stacking
            xyChartNETCtl1.YStacking = true;
            xyChartNETCtl1.NumYStacks = 2;
			// Y Stack 0
			yStack = xyChartNETCtl1.get_YStack(0);
			yStack.HeightPercentage = 70;
			yStack.NumYScales = 2;
			// Y Stack 1
			yStack = xyChartNETCtl1.get_YStack(1);
			yStack.HeightPercentage = 30;
			yStack.NumYScales = 2;

            //Toolbar
            xyChartNETCtl1.Toolbar.Visible = true;
            xyChartNETCtl1.Toolbar.BackColor = this.BackColor;
            xyChartNETCtl1.Toolbar.Dock = XYChartNet.XYChartNETCtl.PositionOptions.poLeft;

            //Format Legend
            xyChartNETCtl1.Legend.Visible = true;
            xyChartNETCtl1.Legend.BorderVisible = false;
            xyChartNETCtl1.Legend.YScaleVisible = false;

            //Scrollbars
            xyChartNETCtl1.Scrollbars.HorizontalVisible = false;
            xyChartNETCtl1.Scrollbars.VerticalVisible = false;

            //Crosshairs
            xyChartNETCtl1.Crosshairs.YCoordInLegend = true;
            xyChartNETCtl1.Crosshairs.Color = Color.Yellow;
            xyChartNETCtl1.Crosshairs.Width = XYChartNet.XYChartNETCtl.WidthOptions.woThreePoint;
            xyChartNETCtl1.Crosshairs.HorizontalVisible = false;
            xyChartNETCtl1.Crosshairs.CoordsBackcolor = Color.Yellow;

			// X Axis 0 Grid & Scale properties
			xAxis = xyChartNETCtl1.get_XAxis(0);
			xAxis.Grid.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
			xAxis.Grid.LineColor = Color.Maroon;
			xAxis.Scale.Visible = true;
			xAxis.Scale.Position = XYChartNet.XYChartNETCtl.ScalePositionOptions.spLeftOrBottom;
			xAxis.Scale.Label = "";
			xAxis.Scale.LabelColor = Color.Maroon;
			xAxis.Scale.TicksColor = Color.Maroon;
			xAxis.Scale.TicksFont = my10Font;

			// X Axis 1 Grid & Scale properties
			xAxis = xyChartNETCtl1.get_XAxis(1);
			xAxis.Grid.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
			xAxis.Grid.LineColor = Color.MidnightBlue;
			xAxis.Scale.Visible = true;
			xAxis.Scale.Position = XYChartNet.XYChartNETCtl.ScalePositionOptions.spRightOrTop;
			xAxis.Scale.Label = "";
			xAxis.Scale.LabelColor = Color.MidnightBlue;
			xAxis.Scale.TicksColor = Color.MidnightBlue;
			xAxis.Scale.TicksFont = my10Font;
            
			// Y Axis 0 Grid & Scale properties
			yAxis = xyChartNETCtl1.get_YAxis(0);
			yAxis.Grid.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
			yAxis.Grid.LineColor = Color.Maroon;
			yAxis.Scale.Visible = true;
			yAxis.Scale.Position = XYChartNet.XYChartNETCtl.ScalePositionOptions.spLeftOrBottom;
			yAxis.Scale.Label = "";
			yAxis.Scale.LabelColor = Color.Maroon;
			yAxis.Scale.TicksColor = Color.Maroon;
			yAxis.Scale.TicksFont = my10Font;
			yAxis.Scale.ScaleMode = XYChartNet.XYChartNETCtl.ScaleModes.smManual;
			yAxis.Scale.ScaleManualMin = 0;
			yAxis.Scale.ScaleManualMax = 100;

			// Y Axis 1 Grid & Scale properties
			yAxis = xyChartNETCtl1.get_YAxis(1);
			yAxis.Grid.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
			yAxis.Grid.LineColor = Color.Maroon;
			yAxis.Scale.Visible = true;
			yAxis.Scale.Position = XYChartNet.XYChartNETCtl.ScalePositionOptions.spRightOrTop;
			yAxis.Scale.Label = "";
			yAxis.Scale.LabelColor = Color.Maroon;
			yAxis.Scale.TicksColor = Color.Maroon;
			yAxis.Scale.TicksFont = my10Font;
			yAxis.Scale.ScaleMode = XYChartNet.XYChartNETCtl.ScaleModes.smManual;
			yAxis.Scale.ScaleManualMin = 0;
			yAxis.Scale.ScaleManualMax = 100;
			
			// Y Axis 2 Grid & Scale properties
			yAxis = xyChartNETCtl1.get_YAxis(2);
			yAxis.Grid.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
			yAxis.Grid.LineColor = Color.MidnightBlue;
			yAxis.Scale.Visible = true;
			yAxis.Scale.Position = XYChartNet.XYChartNETCtl.ScalePositionOptions.spLeftOrBottom;
			yAxis.Scale.Label = "";
			yAxis.Scale.LabelColor = Color.MidnightBlue;
			yAxis.Scale.TicksColor = Color.MidnightBlue;
			yAxis.Scale.TicksFont = my10Font;
			yAxis.Scale.ScaleMode = XYChartNet.XYChartNETCtl.ScaleModes.smManual;
			yAxis.Scale.ScaleManualMin = 0;
			yAxis.Scale.ScaleManualMax = 500;

            // Y Axis 3 Grid & Scale properties
			yAxis = xyChartNETCtl1.get_YAxis(3);
			yAxis.Grid.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
			yAxis.Grid.LineColor = Color.MidnightBlue;
			yAxis.Scale.Visible = true;
			yAxis.Scale.Position = XYChartNet.XYChartNETCtl.ScalePositionOptions.spRightOrTop;
			yAxis.Scale.Label = "";
			yAxis.Scale.LabelColor = Color.MidnightBlue;
			yAxis.Scale.TicksColor = Color.MidnightBlue;
			yAxis.Scale.TicksFont = my10Font;
			yAxis.Scale.ScaleMode = XYChartNet.XYChartNETCtl.ScaleModes.smManual;
			yAxis.Scale.ScaleManualMin = 0;
			yAxis.Scale.ScaleManualMax = 500;

            //Chart & plot formatting
            xyChartNETCtl1.Gradient.GradientOption = XYChartNet.XYChartNETCtl.GradientOptions.goCustom;
            xyChartNETCtl1.Gradient.Orientation = XYChartNet.XYChartNETCtl.OrientationOptions.ooVertical;
            xyChartNETCtl1.Gradient.StartColor = Color.LightCyan;
            xyChartNETCtl1.Gradient.EndColor = Color.LightSkyBlue;
            
            xyChartNETCtl1.Plot.Transparent = true;
            xyChartNETCtl1.Plot.Border.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loNone;

			// Profile 0
			profile = xyChartNETCtl1.get_Profile(0);
			profile.NumSamples = myNumSamples;
			profile.XScale = 0;
			profile.YScale = 0;
			profile.Label = "Profile 0";
			profile.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
			profile.LineWidth = XYChartNet.XYChartNETCtl.WidthOptions.woTwoPoint;
			profile.LineStyle = XYChartNet.XYChartNETCtl.StyleOptions.soSolid;
			profile.LineColor = Color.Maroon;
			profile.MarkerOption = XYChartNet.XYChartNETCtl.LineOptions.loNone;
			profile.SplineTension = 1;
			profile.FillEnabled = true;
            profile.FillColor = Color.FromArgb(190, 255, 0, 0);

			// Profile 1
			profile = xyChartNETCtl1.get_Profile(1);
			profile.XScale = 1;
			profile.YScale = 2;
			profile.Label = "Profile 1";
			profile.StairMode = true;
			profile.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loCustom;
			profile.LineWidth = XYChartNet.XYChartNETCtl.WidthOptions.woTwoPoint;
			profile.LineStyle = XYChartNet.XYChartNETCtl.StyleOptions.soSolid;
			profile.LineColor = Color.MidnightBlue;
			profile.MarkerOption = XYChartNet.XYChartNETCtl.LineOptions.loNone;
			profile.NumSamples = myNumSamples;
			profile.FillEnabled = true;
			profile.FillColor = Color.FromArgb(190, 0, 0, 255);

            //Empty profile just to map to YScale 2
			// Profile 0
			profile = xyChartNETCtl1.get_Profile(2);
			profile.Visible = false;
			profile.DisplayInLegend = false;
			profile.NumSamples = 1;
			
            //Empty profile just to map to YScale 3
			profile = xyChartNETCtl1.get_Profile(3);
			profile.Visible = false;
			profile.DisplayInLegend = false;
			profile.NumSamples = 1;

            //Create random chart data, then feed into XYChartNET
			Random rnd = new Random();
			for (int row = 0; row < myNumSamples; row++)
			{
				// Profile 0
				DataArray[row, 0] = row;
				DataArray[row, 1] = 70 * rnd.NextDouble() + 20;

				// Profile 1
				DataArray[row, 2] = row*25;
				DataArray[row, 3] = 450 * rnd.NextDouble();
			}

			// Feed source array into XYChart
			xyChartNETCtl1.ChartData = DataArray;

            xyChartNETCtl1.Refresh();
        
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(Form1));
            this.xyChartNETCtl1 = new XYChartNet.XYChartNETCtl();
            this.SuspendLayout();
            // 
            // xyChartNETCtl1
            // 
            this.xyChartNETCtl1.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("xyChartNETCtl1.BackgroundImage")));
            this.xyChartNETCtl1.Border.LineOption = XYChartNet.XYChartNETCtl.LineOptions.loNone;
            this.xyChartNETCtl1.CausesValidation = false;
            this.xyChartNETCtl1.Location = new System.Drawing.Point(31, 35);
            this.xyChartNETCtl1.LogEvent.CTRLInstName = "XYChartNETCtl1";
            this.xyChartNETCtl1.LogEvent.FormName = "Form1";
            this.xyChartNETCtl1.Name = "xyChartNETCtl1";
            this.xyChartNETCtl1.Size = new System.Drawing.Size(467, 389);
            this.xyChartNETCtl1.TabIndex = 0;
            this.xyChartNETCtl1.Title.Font = new System.Drawing.Font("Arial", 8F);
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(837, 541);
            this.Controls.Add(this.xyChartNETCtl1);
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Form1";
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
	}
}
